;Always the first step: load the VIGRA CL Lib
(load "vigracl.cl")

(require :climxm)
(use-package :excl)

(in-package :clim-user)

(define-application-frame test ()
  ()
  (:panes   
   (display :application
	    :text-cursor nil
            :width :compute :height :compute))
  (:layouts    
   (default display)))

(define-application-frame test2 ()
  ()
  (:panes   
   (display :application
	    :text-cursor nil
            :width :compute :height :compute))
  (:layouts    
   (default display)))

;(define-test-command (com-quit :menu t) ()
;  (frame-exit *application-frame*))

(defvar *test-frame* nil)

(defun test ()
  (let ((frame (or *test-frame*
		   (setf *test-frame*
		     (make-application-frame 'test)))))
    (mp:process-run-function "CLIMage Viewer" #'run-frame-top-level frame)))

(defvar *test-frame2* nil)

(defun test2 ()
  (let ((frame2 (or *test-frame2*
		   (setf *test-frame2*
		     (make-application-frame 'test2)))))
    (mp:process-run-function "CLIMage Viewer" #'run-frame-top-level frame2)))

(defun draw-image (img pane)
  (if (= (length img) 3)
    (draw-image-rgb img pane)		;RGB
    (draw-image-gray img pane)))	;GRAY

(defun draw-image-gray (img pane)
  (vigracl:array-for-each-index
   #'(lambda(i j) (draw-point* pane j i :ink (make-gray-color (/ (aref (first img) i j) 255)) ))
   (first img)))

(compile 'draw-image)

(defun draw-image-rgb (img pane)
  (let* ((r_arr (first  img))
	 (g_arr (second img))
	 (b_arr (third  img))
  	 (width  (array-dimension r_arr 0))
	 (height (array-dimension r_arr 1)))
   (do* ((j 1 (+ j 1)))
       ((= j (- height 1)))
       (gc :tenure)
       (do* ((i 1 (+ i 1)))
       	  ((= i (- width 1)))
	 (draw-point* pane j i :ink (make-rgb-color (/ (aref arr_r i j) 255)
						    (/ (aref arr_g i j) 255) 
						    (/ (aref arr_b i j) 255)) )))))
(compile 'draw-image)

;;; evaluate the following to create and display the frame:
(defun image-to-pixmap (img)
  (let* ((frame       (test))
 	 ;;; after calling (test) and the frame has appeared evaluate...
  	 (*test-pane* (get-frame-pane *test-frame* 'display))
	 (baz (draw-image img *test-pane*)))
     (copy-to-pixmap  *test-pane* 0 0 (array-dimension (first img) 1) (array-dimension (first img) 0))))

(defun showpixmap (pixmap)
   (let* ((frame2       (test2))
 	 ;;; after calling (test) and the frame has appeared evaluate...
  	 (*test-pane2* (get-frame-pane *test-frame2* 'display))
;	 (border      (draw-rectangle* *test-pane2* 0 0 (pixmap-width pixmap) (pixmap-height pixmap) 
					;				       :filled nil :line-thickness 1))
	  )
   (copy-from-pixmap pixmap  0 0 (pixmap-width pixmap) (pixmap-height pixmap) *test-pane2* 0 0)))

(defun show-image (img (&optional (stream *standard-output*)))
    (let ((medium (clim:sheet-medium stream)))
      (let ((pixmap (clim:with-output-to-pixmap (mv medium)
		      (draw-image img mv))))      
	(copy-from-pixmap pixmap 0 0 (clim:pixmap-width pixmap) (clim:pixmap-height pixmap) medium x y))))



(print "loading blox-image")
(time (setq img (vigracl:loadimage  "images/blox.gif")))
(setq pixmap (image-to-pixmap img))
(show-image img)