(defpackage :vigracl
  (:use  :common-lisp)
  (:export 
           :copy-array 
	   :array-map
	   :array-map!
	   :array-reduce
	   :array-for-each-index
	   :image-map
	   :image-map!
	   :image-reduce
	   :image-for-each-inde
	   
	   :convolveimage-band    
	   :convolveimage
	   :separableconvolveimage-band
	   :separableconvolveimage
	   :gsmooth-band
	   :gsmooth
	   :gaussiangradient-band
	   :gaussiangradient
	   :ggradient-band
	   :ggradient
	   :laplacianofgaussian-band
	   :laplacianofgaussian
	   :gsharpening-band
	   :gsharpening
	   :sharpening-band
	   :sharpening
	   :nonlineardiffusion-band 
	   :nonlineardiffusion 
	   :distancetransform-band 
	   :distancetransform
	   
	   :resizeimage-band
	   :resizeimage
	   :rotateimage-band
	   :rotateimage
	   :affinewarpimage-band
	   :affinewarpimage
	   :reflectimage-band
	   :reflectimage
	   :fouriertransform-band
	   :fouriertransform
	   
	   :loadimage 
	   :saveimage
	   
	   :erodeimage-band
	   :erodeimage
	   :dilateimage-band
	   :dilateimage
	   :openingimage-band
	   :openingimage
	   :closingimage-band
	   :closingimage
	   
	   :labelimage-band
	   :labelimage
	   :watersheds-band
	   :watersheds
	   :cannyedgeimage-band
	   :cannyedgeimage
	   :differenceofexponentialedgeimage-band
	   :differenceofexponentialedgeimage
	   :regionimagetocrackedgeimage-band
	   :regionimagetocrackedgeimage))

(in-package :vigracl)

;Load dll under windows, dylib under MacOS
(if (null (search "Mac" (lisp-implementation-version) :test #'char-equal))
    (load "vigra_c.dll"    )
    (load "libvigra_c.dylib"))

(excl:defsystem :vigracl ()
  (:serial "vigracl.helpers.cl"
	   (:parallel "vigracl.impex.cl"
		      "vigracl.imgproc.cl"
		      "vigracl.filters.cL"
		      "vigracl.segmentation.cl"
		      "vigracl.morphology.cl")))
  
(excl:compile-system :vigracl)
(excl:load-system :vigracl)