;###############################################################################
;###################         Erosion                        ####################

(ff:def-foreign-call vigra_discerosion_c 
    ((arr      (:array :float))
     (arr2     (:array :float))
     (width    :int fixnum) 
     (height   :int fixnum)
     (radius :int fixnum)) 
  :returning  (:int fixnum))

(defun erodeimage-band (arr radius)
  (let* ((width  (array-dimension arr 0))
	 (height (array-dimension arr 1))
	 (arr2 (make-array (list width height)
			   :element-type (array-element-type arr)
			   :initial-element 0.0))
	 (foo   (vigra_discerosion_c arr arr2 width height   radius)))
    (case foo
      ((0) arr2)
      ((1) "Error in vigracl.morphology:erodeimage: Erosion of image failed!!"))))

(defun erodeimage (image radius)
  (mapcar #'(lambda (arr) (erodeimage-band arr radius)) image))

;###############################################################################
;###################         Dilation                       ####################

(ff:def-foreign-call vigra_discdilation_c 
    ((arr      (:array :float))
     (arr2     (:array :float))
     (width    :int fixnum) 
     (height   :int fixnum)
     (radius :int fixnum)) 
  :returning  (:int fixnum))

(defun dilateimage-band (arr radius)
  (let* ((width  (array-dimension arr 0))
	 (height (array-dimension arr 1))
	 (arr2 (make-array (list width height)
			   :element-type (array-element-type arr)
			   :initial-element 0.0))
	 (foo   (vigra_discdilation_c arr arr2 width height   radius)))
    (case foo
      ((0) arr2)
      ((1) "Error in vigracl.morphology:dilateimage: Dilation of image failed!!"))))


(defun dilateimage (image radius)
  (mapcar #'(lambda (arr) (dilateimage-band arr radius)) image))

;###############################################################################
;###################         Opening                        ####################

(defun openingimage-band (arr radius)
  (dilateimage-band (erodeimage-band arr radius) radius))

(defun openingimage (image radius)
  (dilateimage (erodeimage image radius) radius))

;###############################################################################
;###################         Closing                        ####################

(defun closingimage-band (arr radius)
  (erodeimage-band (dilateimage-band arr radius) radius))

(defun closingimage (image radius)
  (erodeimage (dilateimage image radius) radius))
